/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIASIDEBAR_H
#define TAVIASIDEBAR_H

#include <qwidget.h>
#include <qframe.h>
#include <qpopupmenu.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qptrlist.h>
#include <qdatetime.h>
#include <klocale.h>
#include <kconfig.h>
#include <taviasidebarcontainer.h>
#include <taviasidebarcontents.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaSidebar : public QWidget
{
Q_OBJECT
public:
    TaviaSidebar(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TaviaSidebar();


    protected: QLabel *dummy;
    protected: QVBoxLayout *bodyLayout;

    protected: QPtrList<TaviaSidebarContentsInfo> contentsInfo;

    protected: QPopupMenu *newContentsPopup;

    private: void init();
    private: KConfig *config;

    protected slots: void createContents(int i,QString id = QString());

    protected slots: void ncMenuPopup();

    protected: QPtrList<TaviaSidebarContainer> containerList;

    protected slots: void changeActiveContents(TaviaSidebarContainer *c);

    protected slots: void deleteContents(TaviaSidebarContainer *c);
    signals: void openURL(const KURL &url);
    signals: void openURL(const KURL &url,const KParts::URLArgs &args);
    signals: void openURLwithNewTab(const KURL &url);
    signals: void openURLwithNewTab(const KURL &url,const KParts::URLArgs &args);


    protected: QString createUniqueId();

    protected: void saveConfig();
    protected: void loadConfig();
public slots:
    void initSidebar();
};

#endif
