/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIASIDEBARCONTAINER_H
#define TAVIASIDEBARCONTAINER_H

#include <qwidget.h>
#include <qtoolbutton.h>
#include <qpopupmenu.h>
#include <qevent.h>
#include <taviasidebarcontents.h>
#include <kurl.h>
#include <kglobal.h>
#include <klocale.h>
#include <kparts/browserextension.h>


/**
TaviaSidebarƥ

@author TAM(Teppei Tamra)
*/
class TaviaSidebarContainerBar : public QToolButton
{
Q_OBJECT
public:
    TaviaSidebarContainerBar(QWidget * parent, const char * name = 0);
    ~TaviaSidebarContainerBar();
protected:
    virtual void mousePressEvent(QMouseEvent *e);
signals:
    void rightButtonAction();
};

class TaviaSidebarContainer : public QWidget
{
Q_OBJECT
public:
    TaviaSidebarContainer(QWidget *parent = 0, TaviaSidebarContents *c = 0, const char *name = 0, WFlags f = 0);

    ~TaviaSidebarContainer();



    protected: TaviaSidebarContainerBar *labelButton;

    protected: TaviaSidebarContents *contents;

    protected: QPopupMenu *popup;

    public: bool isContentsShown();

    signals: void buttonClicked(TaviaSidebarContainer *c);
    protected slots: void clicked();

    public: void showContents();
    public: void hideContents();

    public: int type;

    signals: void closeContents(TaviaSidebarContainer *c);
    protected slots: void slotClose();
    void menuPopup();


    public: TaviaSidebarContents *getContents();

    public slots: void update();
};

#endif
