/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIASIDEBARCONTENTS_H
#define TAVIASIDEBARCONTENTS_H

#include <qwidget.h>
#include <kurl.h>
#include <kparts/browserextension.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaSidebarContents;

/*!
    \fn TaviaSidebarContentsInfo()
    ɥСƥľ
*/
class TaviaSidebarContentsInfo
{
public:
    //TaviaSidebarContentsInfo();
    //~TaviaSidebarContentsInfo();

    typedef TaviaSidebarContents *func(const QString);

    QString name;   ///< ɥСƥĤθͭ̾
    QString icon;   ///< ̾
    bool multiple;  ///< ʣΥ󥹥󥹤Ĥ뤫ɤ
    func *createContents;    ///< createContentsؤΥݥ
};

class TaviaSidebarContents : public QWidget
{
Q_OBJECT
public:
    TaviaSidebarContents(const QString id,QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TaviaSidebarContents();

    friend class TaviaSidebar;

    private: QString uniqueId;
    signals: void openURL(const KURL &url);
    signals: void openURL(const KURL &url,const KParts::URLArgs &args);
    signals: void openURLwithNewTab(const KURL &url);
    signals: void openURLwithNewTab(const KURL &url,const KParts::URLArgs &args);

    public slots: virtual void currentURLChanged(KURL &url,KParts::URLArgs &args,QString &title);


    public: static TaviaSidebarContents * createContents(const QString id);
    public: static TaviaSidebarContentsInfo * getContentsInfo();
    signals: void update();


    public: virtual const QString getContentsTitle();
    public: virtual const QString getContentsIcon();

    public slots: virtual void configure();

    private: void setUniqueId(QString id);
    protected: const QString getUniqueId();

    public: virtual void closeContents();
};

#endif
