/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TSCHTMLVIEW_H
#define TSCHTMLVIEW_H

#include <taviasidebarcontents.h>
#include <kconfig.h>
#include <kurl.h>
#include <khtml_part.h>
#include <khtmlview.h>
#include <qlayout.h>
#include <qframe.h>
#include <klocale.h>
#include <kdebug.h>
#include <klineedit.h>
#include <qcheckbox.h>


/**
@author TAM(Teppei Tamra)
*/
class TaviaSidebarContents;

class TSCHTMLView : public TaviaSidebarContents
{
Q_OBJECT
public:
    TSCHTMLView(const QString id,QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TSCHTMLView();


    public: static TaviaSidebarContentsInfo * getContentsInfo();

    public: static TaviaSidebarContents * createContents(const QString id);

    public: virtual const QString getContentsTitle();
    public: virtual const QString getContentsIcon();
    protected: KConfig *config;
    protected: KHTMLPart *khtml;

    protected: QString url;
    protected: QString title;
    protected: bool gtfhtml;

    protected: QFrame *configPanel;
    protected: KLineEdit *curl;
    protected: KLineEdit *ctitle;
    protected: QCheckBox *cgtfhtml;

    protected: QString uid;
    protected: void loadConfig();
    protected: void saveConfig();
    protected: bool isClose;
    public: virtual void closeContents();

    protected: void createConfigPanel();

    public slots: virtual void configure();

    protected slots: void configOk();
    protected slots: void configCancel();

    protected slots: void getTitleFromHtml();
};

#endif
