/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TSCLIRSVIEW_H
#define TSCLIRSVIEW_H

#include <taviasidebarcontents.h>
#include <kconfig.h>
#include <qptrlist.h>
#include <klistview.h>
#include <klineedit.h>
#include <qframe.h>
#include <qstringlist.h>
#include <qpopupmenu.h>
#include <qpushbutton.h>

/**
@author TAM(Teppei Tamra)
*/
class LIRSEntry
{
public:
    int lMod;       // Last-Modified
    int lDet;       // Last-Detected
    int td;         // Time Difference
    int cl;         // Content-Length
    QString url;    // URL
    QString title;  // Title
    QString adm;    // Administrator
    QString from;
};

/**
@author TAM(Teppei Tamra)
*/
class TSCLIRSView : public TaviaSidebarContents
{
Q_OBJECT
public:
    TSCLIRSView(const QString id, QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TSCLIRSView();
    static TaviaSidebarContents * createContents(const QString id);
    static TaviaSidebarContentsInfo * getContentsInfo();
    virtual const QString getContentsTitle();
    virtual const QString getContentsIcon();

protected:
    int openLocalList(const QString filename);
    void setListView();
    void createConfigPanel();
    void saveConfig();
    void loadConfig();

public slots:
    virtual void configure();
protected:
    LIRSEntry * entryParse(QString line);
    KListView * flist;
    KLineEdit * fileline;
    QPopupMenu * configMenu;
    QPopupMenu * entryMenu;
    QPtrList<LIRSEntry> entry;
    KListView * listView;
    QFrame *configPanel;
    KConfig *config;
    QPushButton *reload;

protected slots:
    void itemDoubleClicked(QListViewItem *item,const QPoint& p,int c);
    void configPopup(QListViewItem *i,const QPoint &p,int c);
    void entryPopup(QListViewItem *i,const QPoint &p,int c);
    void configAddEntry();
    void configDelEntry();
    void configSelected(QListViewItem *item);
    void configUpdate();
    void configOk();
    void getListFiles();
    void openURLwnt();
};

#endif

