/***************************************************************************
 *   Copyright (C) 2003 by kzk(Kazuki Ohta)                                *
 *   mover@hct.zaq.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef __trssviewpart_dlg_configure_h__
#define __trssviewpart_dlg_configure_h__

#include "tscrssview.h"

#include <kurl.h>
#include <kdialogbase.h>

class QString;
class QPushButton;

class KURL;
class KConfig;
class KLineEdit;
class KListView;
class KIntSpinBox;

class TRSSConfigureDialog : public KDialogBase {
    Q_OBJECT
public:
    TRSSConfigureDialog( KConfig* conf );
    ~TRSSConfigureDialog();

    void readEntry();
    void writeEntry();
    void updateNameList();

public slots:
    void slotApply();
    
    void slotAdd();
    void slotModify();
    void slotDeleteItem();

public:
    bool isModify;
private:
    KConfig* config;

    KListView* siteListView;

    QPushButton* addButton;
    QPushButton* modifyButton;
    QPushButton* deleteButton;
};

class TRSSAddDialog : public KDialogBase
{
    Q_OBJECT
public:
    TRSSAddDialog();
    TRSSAddDialog( QString name, KURL& url, unsigned int interval ); // for Modify
    ~TRSSAddDialog();

    QString getSiteName();
    KURL getSiteURL();
    unsigned int getInterval();

public slots:
    void slotApply();

private:
    void setupGUI();

    KLineEdit* nameEdit;
    KLineEdit* rssUrlEdit;
    KIntSpinBox* intervalSpinBox;
};

#endif
