/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TSESSBBOX_H
#define TSESSBBOX_H

#include <qwidget.h>
#include <qlayout.h>
#include <qtoolbutton.h>
#include <qscrollview.h>
#include <qptrlist.h>
#include <qvbox.h>
#include <kurl.h>
#include <kglobal.h>
#include <kiconloader.h>
#include <kdebug.h>
#include <tsessbutton.h>
#include <tsessscrollview.h>

/**
@author TAM(Teppei Tamra)
*/
class TSESSBBox : public QWidget
{
Q_OBJECT
public:
    TSESSBBox(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TSESSBBox();

    signals: void extWheelActionUp();
    signals: void extWheelActionDown();

    protected: TSESSScrollView *box;
    protected: QToolButton *downButton;
    protected: QToolButton *upButton;
    protected: QVBoxLayout *lay;
    protected: QHBoxLayout *hlay;
    protected: QPtrList<TSESSButton> buttons;
    protected: bool vertical;


    public: void addTSESSButton();
    protected slots: void hover(TSESSButton *b);



    protected: int getButtonNum(TSESSButton *b);
    protected: void layout();

    virtual void resizeEvent(QResizeEvent *e);
//    protected: int selected;

    public slots: void buttonPressed(TSESSButton *b);

    public slots: void select(int num);

    signals: void buttonSelected(int num);

    public: TSESSButton * getTSESSButton(int num);

    public: int delTSESSButton(int num);

    signals: void rightMiniButtonClicked(int num);
    signals: void leftMiniButtonClicked(int num);

    protected slots: void miniButtonClicked(TSESSButton::MiniButton b,TSESSButton * sb);

    public slots: void hoverCheck(int x,int y);

    public: void TSESSButtonRedraw();



    protected slots: void slotDropUrlList(TSESSButton *b,const KURL::List urllist);
    signals: void dropUrlList(int num,const KURL::List urllist);;
    void resized();

    public slots: void downScroll();
    public slots: void upScroll();

    protected: int buttonSize;
    bool freeScale;

    public: int getButtonSize();
    public: void setButtonSize(int size);
    bool isFreeScale();
    void setFreeScale(bool b);
    public slots: virtual void setVertical(bool v);
};


#endif
