/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TSESSBUTTON_H
#define TSESSBUTTON_H

#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qframe.h>
#include <qpixmap.h>
#include <qevent.h>
#include <ksqueezedtextlabel.h>
#include <kurldrag.h>
#include <kurl.h>
#include <kdebug.h>
#include <tsessminibutton.h>

class QToolButton;
class KSqueezedTextLabel;


/**
@author TAM(Teppei Tamra)
*/
class TSESSButton : public QWidget
{
Q_OBJECT
public:
    TSESSButton(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TSESSButton();

    enum Styles {
        Plain = 0,
        Raised,
        Sunken
    };
    enum MiniButton {
        None = 0,
        Left,
        Right,
        Both
    };
/*    enum ButtonSize {
        Small = 80,
        Normal = 120,
        Large = 200
    };*/
    private: KSqueezedTextLabel *tLabel;
    public: TSESSMiniButton *tLeftButton;
    public: TSESSMiniButton *tRightButton;
    private: QFrame *tFrame;
    private: QLabel *tIcon;
    private: QGridLayout *tLay;
    private: QVBoxLayout *tVBoxLay;
    private: QHBoxLayout *tHBoxLay;
    private: QPixmap tIconPixmap;
    private: QPixmap tOrigIconPixmap;

    public slots: void setIcon(const QPixmap &pixmap);
    public slots: void setIcon();
    public slots: void setLabel(const QString &label);


    public slots: void tButtonRaised();
    public slots: void tButtonSunken();
    public slots: void tButtonPlain();

    protected: virtual void mousePressEvent(QMouseEvent *e);
    protected: virtual void mouseReleaseEvent(QMouseEvent *e);

    protected: Styles buttonStyle;

    public slots: void showMiniButton();
    public slots: void hideMiniButton();

    public slots: void setMiniButton(MiniButton b);


    signals: void hover(TSESSButton *b);

    public: TSESSButton::Styles getButtonStyle();

    protected: MiniButton miniButtons;

    signals: void buttonPressed(TSESSButton *b);

    signals: void miniButtonClicked(TSESSButton::MiniButton b,TSESSButton *sb);

    private slots: void leftMiniButtonClicked();
    private slots: void rightMiniButtonClicked();

    protected: virtual void dragEnterEvent(QDragEnterEvent *event);
    protected: virtual void dropEvent(QDropEvent *event);

    signals: void dropUrlList(TSESSButton *b,const KURL::List);

    protected: int buttonSize;

    public: unsigned int setButtonSize(int size);
};

#endif
