/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "tsessminibutton.h"

TSESSMiniButton::TSESSMiniButton(QWidget *parent, const char *name, WFlags f)
 : QLabel(parent, name, f)
{
    setMouseTracking(false);
}


TSESSMiniButton::~TSESSMiniButton()
{
}

/*!
    \fn TSESSMiniButton::setText(const QString &text)
 */
void TSESSMiniButton::setText(const QString &text)
{
    // ToolTipsǤ褦
}

/*!
    \fn TSESSMiniButton::setIconSet(const QIconSet &i)
 */
void TSESSMiniButton::setIconSet(const QIconSet &i)
{
    icon = i;
    setPixmap(icon.pixmap(QIconSet::Automatic,QIconSet::Normal,QIconSet::Off));
}

/*!
    \fn TSESSMiniButton::mousePressEvent(QMouseEvent *e)
 */
void TSESSMiniButton::mousePressEvent(QMouseEvent *e)
{
    setPixmap(icon.pixmap(QIconSet::Automatic,QIconSet::Normal,QIconSet::On));
}

/*!
    \fn TSESSMiniButton::mouseReleaseEvent(QMouseEvent *e)
 */
void TSESSMiniButton::mouseReleaseEvent(QMouseEvent *e)
{
    setPixmap(icon.pixmap(QIconSet::Automatic,QIconSet::Normal,QIconSet::Off));
    // ʤ󤫤äȥʤ
    if (e->button() == LeftButton &&
        e->x() <= pixmap()->width() &&
        e->x() >= 0 &&
        e->y() <= pixmap()->height() &&
        e->y() >= 0) {
        emit clicked();
    }
}






#include "tsessminibutton.moc"
