/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "tsessscrollview.h"

TSESSScrollView::TSESSScrollView(QWidget *parent, const char *name, WFlags f)
 : QScrollView(parent, name, f)
{
    setMouseTracking(true);
    viewport()->setMouseTracking(true);
}


TSESSScrollView::~TSESSScrollView()
{
}

/*!
    \fn TSESSScrollView::contentsMouseMoveEvent ( QMouseEvent * e )
 */
void TSESSScrollView::contentsMouseMoveEvent ( QMouseEvent * e )
{
    emit tMouseMoveEvent(e->x(),e->y());
}

/*!
    \fn TSESSScrollView::contentsWheelEvent(QWheelEvent * e)
 */
void TSESSScrollView::contentsWheelEvent(QWheelEvent * e)
{
    if (e->state() == Qt::ControlButton) {
        if (e->delta() >= 0) emit extWheelActionUp();
        else emit extWheelActionDown();
    } else {
        if (e->delta() >= 0) {
            if (contentsWidth() > contentsHeight()) {
                scrollBy(-100,0);
            } else {
                scrollBy(0,-100);
            }
        } else {
            if (contentsWidth() > contentsHeight()) {
                scrollBy(100,0);
            } else {
                scrollBy(0,100);
            }
        }
        //QScrollView::contentsWheelEvent(e);
    }
}



