/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TSESSVIEW_H
#define TSESSVIEW_H

#include <qwidget.h>
#include <qlayout.h>
#include <qframe.h>
#include <qptrlist.h>
#include <qsplitter.h>
#include <kdebug.h>
#include <tsessbbox.h>

/**
@author TAM(Teppei Tamra)
*/
class TSESSView : public QWidget
{
Q_OBJECT
public:
    TSESSView(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TSESSView();


    private: QHBoxLayout *hlay;
    private: QVBoxLayout *vlay;
    private: QBoxLayout *lay;

    protected: bool vertical;
    protected: TSESSBBox *tSessBBox;
    protected: QPtrList<QFrame> frames;

    protected: int tAddFrame();
    protected: int tDelFrame(int num);

    public: void delFrame(int num);
    public: int addFrame();



    protected: void tSelect(int num);
    public: int getSelected();


    protected: int selected;

    public: QFrame * getFrame(int num);

    public slots: void setSelected(int num);
    public: TSESSButton * getTSESSButton(int num);



    public: int getNumFromFrame(QFrame *f);

    protected: QFrame *dummyFrame;

    signals: void TSESSDeleted(int num);

    signals: void changed(int num);

    protected slots: void slotDropUrlList(int num,const KURL::List urllist);
    public slots: void setVerticalBox(bool v);
    signals: void dropUrlList(int num,const KURL::List urllist);

    public: int count();

    signals: void TSESSBBoxShown(bool b);
    public slots: void setBBoxShow(bool b);

    public: void setButtonSize(int size);
    TSESSBBox * getBBox();
};


#endif
