/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAFILEIO_H
#define TAVIAFILEIO_H

#include <qobject.h>
#include <kparts/browserextension.h>
#include <qptrlist.h>
#include <kurl.h>
#include <kio/scheduler.h>
#include <kio/job.h>
#include <kio/jobclasses.h>


/**
@author TAM(Teppei Tamra)
*/
class TaviaFileIO : public QObject
{
Q_OBJECT
public:
    TaviaFileIO(QObject *parent = 0, const char *name = 0);

    ~TaviaFileIO();
    int get(const KURL &url,const KParts::URLArgs &args);
    KURL getURL(int job);
    int mimetype(const KURL &url,const KParts::URLArgs &args);
protected:
    QPtrList<KIO::Job> jobs;
protected slots:
    void slotData(KIO::Job *job, const QByteArray &data);
    void slotMimeType(KIO::Job *job, const QString &type);
signals:
    void sendData(int job,const QByteArray data);
    void sendMimeType(int job,const QString type);
};

#endif
