/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "taviahtmlpopup.h"

#include <qcursor.h>
#include <qptrlist.h>
#include <klocale.h>
#include <kaboutdata.h>
#include <kglobal.h>
#include <kstandarddirs.h>
#include <kdebug.h>
#include <khtml_part.h>
#include <kparts/browserextension.h>



TaviaHTMLPopup::TaviaHTMLPopup(TaviaHTMLView *parent, const char *name)
 : QPopupMenu(0,name),KXMLGUIClient()
{
    htmlview = parent;
    openAction = new KAction(i18n("open link"),0,0,this,SLOT(linkOpen()),actionCollection(),"linkOpen");
    openTabAction = new KAction(i18n("open link with new tab"),0,0,this,SLOT(linkOpenWithNewTab()),actionCollection(),"linkOpen");
}


TaviaHTMLPopup::~TaviaHTMLPopup()
{
}

/*!
    \fn TaviaHTMLPopup::createLinkURLPopup(const KURL &url)
 */
void TaviaHTMLPopup::createLinkURLPopup(const KURL &url)
{
    if (!url.isEmpty()) {
        openAction->plug(this);
        openTabAction->plug(this);
        /* ͥդpopup¸
        QLabel *pantira = new QLabel(this);
        pantira->setText("PANTIRA");
        for (unsigned int i = 0;i < htmlview->urlHistory.count();i ++) {
            if (htmlview->urlHistory.at(i)->url.url() == url.url())
                pantira->setPixmap(htmlview->urlHistory.at(i)->thumbnail);
        }
        insertItem(pantira);
        */
    }
}

/*!
    \fn TaviaHTMLPopup::createCurrentURLPopup(const KURL &url)
 */
void TaviaHTMLPopup::createCurrentURLPopup(const KURL &url)
{
}

/*!
    \fn TaviaHTMLPopup::createToolPopup()
 */
void TaviaHTMLPopup::createToolPopup()
{
}

/*!
    \fn TaviaHTMLPopup::menuPopup(const KURL &current,const KURL &link)
 */
void TaviaHTMLPopup::menuPopup(const KURL &current,const KURL &link)
{
    linkURL = link;
    currentURL = current;
    clear();
    createLinkURLPopup(link);
    createCurrentURLPopup(current);
    createToolPopup();

    emit popup(QCursor::pos());
}

/*!
    \fn TaviaHTMLPopup::linkOpen()
 */
void TaviaHTMLPopup::linkOpen()
{
    emit htmlview->slotOpenURL(linkURL,htmlview->browserExtension()->urlArgs());
}

/*!
    \fn TaviaHTMLPopup::linkOpenWithNewTab()
 */
void TaviaHTMLPopup::linkOpenWithNewTab()
{
    KParts::URLArgs args = htmlview->browserExtension()->urlArgs();
    args.frameName = "_blank";
    emit htmlview->slotOpenURL(linkURL,args);
}





