/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAHTMLPOPUP_H
#define TAVIAHTMLPOPUP_H

#include <qobject.h>
#include <qlabel.h>
#include <qpopupmenu.h>
#include <kaction.h>
#include <kxmlguiclient.h>
#include <taviahtmlview.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaHTMLPopup : public QPopupMenu,public KXMLGUIClient
{
Q_OBJECT
public:
    TaviaHTMLPopup(TaviaHTMLView *parent = 0, const char *name = 0);

    ~TaviaHTMLPopup();

private:
    TaviaHTMLView *htmlview;
    KURL currentURL;
    KURL linkURL;
    KAction *openAction;
    KAction *openTabAction;

protected:
    void createLinkURLPopup(const KURL &url);
    void createCurrentURLPopup(const KURL &url);
    void createToolPopup();

public slots:
    void menuPopup(const KURL &current,const KURL &link);

protected slots:
    void linkOpen();
    void linkOpenWithNewTab();
    
};

#endif
