/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAQNAVI_H
#define TAVIAQNAVI_H

#include <qwidget.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <qvaluelist.h>
#include <kdebug.h>

#include <taviatab.h>

/**
@author TAM(Teppei Tamra)
*/
class TaviaQNavi : public QWidget
{
Q_OBJECT
public:
    TaviaQNavi(QWidget *parent = 0, TaviaTab *taviatab = 0, const char *name = 0, WFlags f = 0);

    ~TaviaQNavi();

protected:
    virtual void mousePressEvent(QMouseEvent * e);
    virtual void mouseMoveEvent(QMouseEvent * e);
    virtual void wheelEvent(QWheelEvent * e);
    virtual void mouseReleaseEvent(QMouseEvent * e);
    void createThumbnails();
    void changeThumbnail();

protected:
    QPoint defPoint;
    TaviaTab * tab;
    bool dragMove;
    QPixmap nataFrame;
    QValueList<QPixmap> thumbnails;
    bool busy;

signals:
    void qnaviClose();
};

#endif
