/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIARUN_H
#define TAVIARUN_H

#include <kparts/browserrun.h>
#include "taviahtmlview.h"

/**
@author TAM(Teppei Tamra)
*/

class TaviaHTMLView;
class TaviaRun : public KParts::BrowserRun
{
Q_OBJECT
public:
    TaviaRun(const KURL &url, const KParts::URLArgs &args, TaviaHTMLView *part, QWidget *window, bool removeReferrer, bool trustedSource, bool hideErrorDialog);

    ~TaviaRun();

protected:
    TaviaHTMLView *htmlView;
    KURL srcURL;
    KParts::URLArgs srcURLArgs;
protected:
    virtual void foundMimeType(const QString &_type);
    virtual void scanFile();
signals:
    void appRun();
protected slots:
    void slotRedirection(KIO::Job *job, const KURL& toURL);
};

#endif
