/***************************************************************************
 *   Copyright (C) 2003 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TAVIAURLBAR_H
#define TAVIAURLBAR_H

#include <qwidget.h>
#include <qlayout.h>
#include <qlabel.h>
#include <kglobal.h>
#include <kiconloader.h>
#include <klocale.h>
#include <kdebug.h>
#include <kcombobox.h>
#include <kurlcombobox.h>
#include <qtoolbutton.h>

/**
@author TAM(Teppei Tamra)
*/
class KComboBox;
class TaviaURLBar : public QWidget
{
Q_OBJECT
public:
    TaviaURLBar(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

    ~TaviaURLBar();


protected:
    KURLComboBox * uCombo;
    QToolButton * urlEnter;
    QToolButton * urlErase;
    QStringList compList;

public slots:
    virtual void setFocus();
    virtual void setEnabled(bool b);
    void addURLHistory(const KURL &url);
    void setEditURL(const KURL &url);

protected slots:
    void clearURLBar();
    void returnPressed();
    void slotEnterURL(const KURL &url);

signals:
    void enterURL(const KURL &url);


};

#endif
